> ## Documentation Index
> Fetch the complete documentation index at: https://stytch.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Log In Or Create User

> Use an email magic link to log in or create a new user.

Send either a login or signup Magic Link to the User depending on if the email is associated with a User already. A new or pending User will receive a `signup` Magic Link. An active User will receive a `login` Magic Link

For more information on how to control the status your Users are created in see [`create_user_as_pending`](#body-create-user-as-pending).


## OpenAPI

````yaml POST /v1/magic_links/email/login_or_create
openapi: 3.0.3
info:
  title: Stytch API
  description: The Stytch API provides endpoints for authentication and user management.
  version: 2.1.1
  contact:
    name: Stytch Support
    url: https://stytch.com/docs
    email: support@stytch.com
servers:
  - url: https://api.stytch.com
    description: Production server
  - url: https://test.stytch.com
    description: Test server
security:
  - basicAuth: []
paths:
  /v1/magic_links/email/login_or_create:
    post:
      tags:
        - Magic Links
      summary: Loginorcreate
      description: >-
        Send either a login or signup Magic Link to the User based on if the
        email is associated with a User already. A new or pending User will
        receive a signup Magic Link. An active User will receive a login Magic
        Link. For more information on how to control the status your Users are
        created in see the `create_user_as_pending` flag.


        ### Next steps

        The User is emailed a Magic Link which redirects them to the provided
        [redirect
        URL](https://stytch.com/docs/guides/magic-links/email-magic-links/redirect-routing).
        Collect the `token` from the URL query parameters and call [Authenticate
        Magic Link](https://stytch.com/docs/api/authenticate-magic-link) to
        complete authentication.
      operationId: api_magic_v1_magic_links_email_LoginOrCreate
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: >-
                #/components/schemas/api_magic_v1_magic_links_email_LoginOrCreateRequest
      responses:
        '200':
          description: Successful response
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/api_magic_v1_magic_links_email_LoginOrCreateResponse
        '400':
          description: Bad request
        '401':
          description: Unauthorized
          content:
            application/json:
              example:
                status_code: 401
                request_id: request-id-test-b05c992f-ebdc-489d-a754-c7e70ba13141
                error_type: unauthorized_credentials
                error_message: Unauthorized credentials.
                error_url: https://stytch.com/docs/api/errors/401
        '429':
          description: Too Many Requests
          content:
            application/json:
              example:
                status_code: 429
                request_id: request-id-test-b05c992f-ebdc-489d-a754-c7e70ba13141
                error_type: too_many_requests
                error_message: Too many requests have been made.
                error_url: https://stytch.com/docs/api/errors/429
        '500':
          description: Internal server error
          content:
            application/json:
              example:
                status_code: 500
                request_id: request-id-test-b05c992f-ebdc-489d-a754-c7e70ba13141
                error_type: internal_server_error
                error_message: >-
                  Oops, something seems to have gone wrong, please reach out to
                  support@stytch.com to let us know what went wrong.
                error_url: https://stytch.com/docs/api/errors/500
      x-code-samples:
        - lang: csharp
          label: C#
          source: |-
            // POST /v1/magic_links/email/login_or_create
            const stytch = require('stytch');

            const client = new stytch.Client({
              project_id: '${projectId}',
              secret: '${secret}',
            });

            const params = {
              email: "sandbox@stytch.com",
            };

            client.MagicLinks.Email.LoginOrCreate(params)
              .then(resp => { console.log(resp) })
              .catch(err => { console.log(err) });
        - lang: go
          label: Go
          source: "// POST /v1/magic_links/email/login_or_create\npackage main\n\nimport (\n\t\"context\"\n\t\"log\"\n\n\t\"github.com/stytchauth/stytch-go/v18/stytch/consumer/magiclinks/email\"\n\t\"github.com/stytchauth/stytch-go/v18/stytch/consumer/stytchapi\"\n)\n\nfunc main() {\n\tclient, err := stytchapi.NewClient(\n\t\t\"${projectId}\",\n\t\t\"${secret}\",\n\t)\n\tif err != nil {\n\t\tlog.Fatalf(\"error instantiating client: %v\", err)\n\t}\n\n\tparams := &email.LoginOrCreateParams{\n\t\tEmail: \"sandbox@stytch.com\",\n\t}\n\n\tresp, err := client.MagicLinks.Email.LoginOrCreate(context.Background(), params)\n\tif err != nil {\n\t\tlog.Fatalf(\"error in method call: %v\", err)\n\t}\n\n\tlog.Println(resp)\n}\n"
        - lang: java
          label: Java
          source: >-
            // POST /v1/magic_links/email/login_or_create

            package com.example;


            import com.stytch.java.common.StytchResult;

            import
            com.stytch.java.consumer.models.magiclinksemail.LoginOrCreateRequest;

            import com.stytch.java.consumer.StytchClient;


            public class Main {
                public static void main(String[] args) {
                    StytchClient.configure("${projectId}", "${secret}");

                    LoginOrCreateRequest params = new LoginOrCreateRequest();
                    params.setEmail("sandbox@stytch.com");

                    Object result = StytchClient.getMagicLinks().getEmail().loginOrCreate(params);
                    if (result instanceof StytchResult.Success) {
                      System.out.println(((StytchResult.Success) result).getValue());
                    } else {
                      System.out.println(((StytchResult.Error) result).getException());
                    }
                }
            }
        - lang: kotlin
          label: Kotlin
          source: >
            // POST /v1/magic_links/email/login_or_create

            package com.example


            import com.stytch.java.consumer.StytchClient

            import
            com.stytch.java.consumer.models.magiclinksemail.LoginOrCreateRequest


            fun main() {
                StytchClient.configure(
                    projectId = "${projectId}",
                    secret = "${secret}",
                )

                when (
                    val result =
                        StytchClient.magicLinks.email.loginOrCreate(
                            LoginOrCreateRequest(
                                email = "sandbox@stytch.com",
                            ),
                        )
                ) {
                    is StytchResult.Success -> println(result.value)
                    is StytchResult.Error -> println(result.exception)
                }
            }
        - lang: javascript
          label: Node.js
          source: |-
            // POST /v1/magic_links/email/login_or_create
            const stytch = require('stytch');

            const client = new stytch.Client({
              project_id: '${projectId}',
              secret: '${secret}',
            });

            const params = {
              email: "sandbox@stytch.com",
            };

            client.magicLinks.email.loginOrCreate(params)
              .then(resp => { console.log(resp) })
              .catch(err => { console.log(err) });
        - lang: php
          label: PHP
          source: |-
            $response = $client->magic_links->email->login_or_create([
                'email' => 'sandbox@stytch.com',
            ]);
        - lang: python
          label: Python
          source: |
            # POST /v1/magic_links/email/login_or_create
            from stytch import Client

            client = Client(
                project_id="${projectId}",
                secret="${secret}",
            )

            resp = client.magic_links.email.login_or_create(
                email="sandbox@stytch.com",
            )

            print(resp)
        - lang: ruby
          label: Ruby
          source: |-
            # frozen_string_literal: true

            # POST /v1/magic_links/email/login_or_create
            require 'stytch'

            client = Stytch::Client.new(
              project_id: "${projectId}",
              secret: "${secret}"
            )

            resp = client.magic_links.email.login_or_create(
              email: "sandbox@stytch.com"
              
            )

            puts resp
        - lang: rust
          label: Rust
          source: |-
            // POST /v1/magic_links/email/login_or_create
            use stytch::consumer::client::Client;
            use stytch::consumer::magic_links_email::LoginOrCreateRequest;

            fn main() {
                let client = Client::new("${projectId}", "${secret}").unwrap();
                let resp = client.magic_links.email.login_or_create(
                    LoginOrCreateRequest{
                        email: "sandbox@stytch.com",
                        ..Default::default()
                    }
                ).await;
                println!("The response is {:?}", resp);
            }
        - lang: bash
          label: cURL
          source: |-
            # POST /v1/magic_links/email/login_or_create
            curl --request POST \
              --url https://test.stytch.com/v1/magic_links/email/login_or_create \
              -u '${projectId}:${secret}' \
              -H 'Content-Type: application/json' \
              -d '{
                "email": "sandbox@stytch.com"
              }'
components:
  schemas:
    api_magic_v1_magic_links_email_LoginOrCreateRequest:
      type: object
      properties:
        email:
          type: string
          description: The email address of the end user.
        login_magic_link_url:
          type: string
          description: >-
            The URL the end user clicks from the login Email Magic Link. This
            should be a URL that your app receives and parses and subsequently
            send an API request to authenticate the Magic Link and log in the
            User. If this value is not passed, the default login redirect URL
            that you set in your Dashboard is used. If you have not set a
            default login redirect URL, an error is returned.
        signup_magic_link_url:
          type: string
          description: >-
            The URL the end user clicks from the sign-up Email Magic Link. This
            should be a URL that your app receives and parses and subsequently
            send an API request to authenticate the Magic Link and sign-up the
            User. If this value is not passed, the default sign-up redirect URL
            that you set in your Dashboard is used. If you have not set a
            default sign-up redirect URL, an error is returned.
        login_expiration_minutes:
          type: integer
          format: int32
          description: >-
            Set the expiration for the login email magic link, in minutes. By
            default, it expires in 1 hour. The minimum expiration is 5 minutes
            and the maximum is 7 days (10080 mins).
        signup_expiration_minutes:
          type: integer
          format: int32
          description: >-
            Set the expiration for the sign-up email magic link, in minutes. By
            default, it expires in 1 week. The minimum expiration is 5 minutes
            and the maximum is 7 days (10080 mins).
        login_template_id:
          type: string
          description: >-
            Use a custom template for login emails. By default, it will use your
            default email template. Templates can be added in the [Stytch
            dashboard](https://stytch.com/dashboard/templates) using our
            built-in customization options or custom HTML templates with type
            “Magic links - Login”.
        signup_template_id:
          type: string
          description: >-
            Use a custom template for sign-up emails. By default, it will use
            your default email template. Templates can be added in the [Stytch
            dashboard](https://stytch.com/dashboard/templates) using our
            built-in customization options or custom HTML templates with type
            “Magic links - Sign-up”.
        attributes:
          $ref: '#/components/schemas/api_attribute_v1_Attributes'
          description: >-
            Provided attributes to help with fraud detection. These values are
            pulled and passed into Stytch endpoints by your application.
        create_user_as_pending:
          type: boolean
          description: >-
            Flag for whether or not to save a user as pending vs active in
            Stytch. Defaults to false.
                    If true, users will be saved with status pending in Stytch's backend until authenticated.
                    If false, users will be created as active. An example usage of
                    a true flag would be to require users to verify their phone by entering the OTP code before creating
                    an account for them.
        code_challenge:
          type: string
          description: >-
            A base64url encoded SHA256 hash of a one time secret used to
            validate that the request starts and ends on the same device.
        locale:
          $ref: >-
            #/components/schemas/api_magic_v1_magic_links_email_LoginOrCreateRequestLocale
          description: >-
            Used to determine which language to use when sending the user this
            delivery method. Parameter is an [IETF BCP 47 language
            tag](https://www.w3.org/International/articles/language-tags/), e.g.
            `"en"`.


            If no value is provided, the copy defaults to English.
      description: Request type
      required:
        - email
    api_magic_v1_magic_links_email_LoginOrCreateResponse:
      type: object
      properties:
        request_id:
          type: string
          description: >-
            Globally unique UUID that is returned with every API call. This
            value is important to log for debugging purposes; we may ask for
            this value to help identify a specific API call when helping you
            debug an issue.
        user_id:
          type: string
          description: The unique ID of the affected User.
        email_id:
          type: string
          description: The unique ID of a specific email address.
        user_created:
          type: boolean
          description: >-
            In `login_or_create` endpoints, this field indicates whether or not
            a User was just created.
        status_code:
          type: integer
          format: int32
          description: >-
            The HTTP status code of the response. Stytch follows standard HTTP
            response status code patterns, e.g. 2XX values equate to success,
            3XX values are redirects, 4XX are client errors, and 5XX are server
            errors.
      required:
        - request_id
        - user_id
        - email_id
        - user_created
        - status_code
    api_attribute_v1_Attributes:
      type: object
      properties:
        ip_address:
          type: string
          description: The IP address of the user.
        user_agent:
          type: string
          description: The user agent of the User.
    api_magic_v1_magic_links_email_LoginOrCreateRequestLocale:
      type: string
      enum:
        - en
        - es
        - pt-br
        - fr
  securitySchemes:
    basicAuth:
      type: http
      scheme: basic

````